------------------------------------------------------------------------------
--                                                                          --
--                An Ada2005 binding to the Qt C++ framework                --
--                                                                          --
------------------------------------------------------------------------------
--                                                                          --
-- Copyright © 2009, 2010 Vadim Godunko <vgodunko@gmail.com>                --
--                                                                          --
-- QtAda is free software;  you can  redistribute it and/or modify it under --
-- terms of the  GNU General Public License as published  by the Free Soft- --
-- ware  Foundation;  either version 2,  or (at your option) any later ver- --
-- sion. QtAda is distributed in the hope that it will be useful, but WITH- --
-- OUT ANY WARRANTY;  without even the  implied warranty of MERCHANTABILITY --
-- or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License --
-- for  more details.  You should have  received  a copy of the GNU General --
-- Public License distributed with QtAda;  see file COPYING.  If not, write --
-- to  the  Free Software Foundation,  51  Franklin  Street,  Fifth  Floor, --
-- Boston, MA 02110-1301, USA.                                              --
--                                                                          --
-- As a special exception,  if other files  instantiate  generics from this --
-- unit, or you link  this unit with other files  to produce an executable, --
-- this  unit  does not  by itself cause  the resulting  executable  to  be --
-- covered  by the  GNU  General  Public  License.  This exception does not --
-- however invalidate  any other reasons why  the executable file  might be --
-- covered by the  GNU Public License.                                      --
--                                                                          --
------------------------------------------------------------------------------
--    This file has been generated automatically. Please don't edit it.     --
------------------------------------------------------------------------------
with Qt4.Graphics_Items;
with Qt4.Painter_Paths;
with Qt4.Painters;
with Qt4.Point_Fs;
with Qt4.Rect_Fs;
with Qt4.Style_Option_Graphics_Items;
with Qt4.Widgets;

package Qt_Ada.Internals.Graphics_Items.Graphics_Item_Proxies is

   pragma Elaborate_Body;

   type Q_Graphics_Item_Proxy is
     new Qt_Ada.Internals.Graphics_Items.Q_Graphics_Item_Impl_Base
       and Qt4.Graphics_Items.Q_Graphics_Item with null record;

   procedure Advance
    (Self : not null access Q_Graphics_Item_Proxy;
     Phase : Qt4.Q_Integer);

   function Bounding_Rect
    (Self : not null access constant Q_Graphics_Item_Proxy)
       return Qt4.Rect_Fs.Q_Rect_F;

   function Collides_With_Item
    (Self : not null access constant Q_Graphics_Item_Proxy;
     Other : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class;
     Mode : Qt4.Item_Selection_Mode)
       return Standard.Boolean;

   function Collides_With_Path
    (Self : not null access constant Q_Graphics_Item_Proxy;
     Path : Qt4.Painter_Paths.Q_Painter_Path;
     Mode : Qt4.Item_Selection_Mode)
       return Standard.Boolean;

   function Contains
    (Self : not null access constant Q_Graphics_Item_Proxy;
     Point : Qt4.Point_Fs.Q_Point_F)
       return Standard.Boolean;

   function Is_Obscured_By
    (Self : not null access constant Q_Graphics_Item_Proxy;
     Item : not null access constant Qt4.Graphics_Items.Q_Graphics_Item'Class)
       return Standard.Boolean;

   function Opaque_Area
    (Self : not null access constant Q_Graphics_Item_Proxy)
       return Qt4.Painter_Paths.Q_Painter_Path;

   function Shape
    (Self : not null access constant Q_Graphics_Item_Proxy)
       return Qt4.Painter_Paths.Q_Painter_Path;

   overriding
   procedure Paint
    (Self    : not null access Q_Graphics_Item_Proxy;
     Painter : in out Qt4.Painters.Q_Painter'Class;
     Option  :
       Qt4.Style_Option_Graphics_Items.Q_Style_Option_Graphics_Item'Class;
     Widget  : access Qt4.Widgets.Q_Widget'Class := null);

end Qt_Ada.Internals.Graphics_Items.Graphics_Item_Proxies;
